Public Class Bars3EDiv
    Dim KdivE1, KdivE2 As Integer   '開始要素番号、終了要素番号
    Dim Ndiv As Integer         '分割数
    Dim Xadd(), Yadd(), Zadd() As Single  '追加節点の座標

    Private Sub Assemble(ByVal ie As Integer, ByVal kind As Integer)
        '集合処理
        'ie･･･要素番号
        'kind･･･要素種類
        Dim i, i1, i2, ib, ii, j, ksb, nb, nelemb, npointb, numb As Integer
        Dim angleb As Single
        Dim kbuf(Nelem), nnbuf(Nelem, 2), nummbuf(Nelem) As Integer
        Dim angleybuf(Nelem), xbuf(Npoint), ybuf(Npoint), zbuf(Npoint) As Single

        For i = 1 To Nelem
            For j = 1 To 2
                nnbuf(i, j) = NNelem(i, j)
            Next j
            nummbuf(i) = NumMat(i)
            angleybuf(i) = AngleYBar(i)
            If Ntype > 2 Then
                kbuf(i) = KindElem(i)
            End If
        Next i
        For i = 1 To Npoint
            xbuf(i) = Xdata(i)
            ybuf(i) = Ydata(i)
            zbuf(i) = Zdata(i)
        Next i
        nelemb = Nelem
        npointb = Npoint
        nb = Ndiv - 1
        Nelem = Nelem + nb
        Npoint = Npoint + nb
        ReDim KindElem(Nelem), NNelem(Nelem, 2), NumMat(Nelem)
        ReDim AngleYBar(Nelem), Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)
        For i = 1 To nelemb
            For j = 1 To 2
                NNelem(i, j) = nnbuf(i, j)
            Next j
            NumMat(i) = nummbuf(i)
            AngleYBar(i) = angleybuf(i)
            If Ntype > 2 Then
                KindElem(i) = kbuf(i)
            End If
        Next i
        For i = 1 To npointb
            Xdata(i) = xbuf(i)
            Ydata(i) = ybuf(i)
            Zdata(i) = zbuf(i)
        Next i

        For i = 1 To nb
            j = npointb + i
            Xdata(j) = Xadd(i)
            Ydata(j) = Yadd(i)
            Zdata(j) = Zadd(i)
        Next i

        numb = NumMat(ie)
        angleb = AngleYBar(ie)
        ksb = 0
        If Nsurf > 0 Then
            For i = 1 To Nsurf
                If ie = KEsurf(i) Then
                    ksb = i
                    Exit For
                End If
            Next i
        End If
        If ksb > 0 Then
            Nsurfb = Nsurf
            Dim kehbuf(Nsurfb) As Integer
            Dim pnybuf(Nsurfb), pnzbuf(Nsurfb), ptbuf(Nsurfb) As Single
            For ib = 1 To Nsurfb
                kehbuf(ib) = KEsurf(ib)
                pnybuf(ib) = PnormYB(ib)
                pnzbuf(ib) = PnormZB(ib)
                ptbuf(ib) = Ptang(ib)
            Next ib
            Nsurf = Nsurfb + nb
            ReDim KEsurf(Nsurf)
            ReDim PnormYB(Nsurf), PnormZB(Nsurf), Ptang(Nsurf)
            For ib = 1 To Nsurfb
                KEsurf(ib) = kehbuf(ib)
                PnormYB(ib) = pnybuf(ib)
                PnormZB(ib) = pnzbuf(ib)
                Ptang(ib) = ptbuf(ib)
            Next ib
            For i = 1 To nb
                i1 = nelemb + i
                i2 = Nsurfb + i
                KEsurf(i2) = i1
                PnormYB(i2) = PnormYB(ksb)
                PnormZB(i2) = PnormZB(ksb)
                Ptang(i2) = Ptang(ksb)
            Next i
        End If

        For i = 1 To nb
            ii = nelemb + i
            NNelem(ii, 1) = npointb + i
            If i < nb Then
                NNelem(ii, 2) = npointb + i + 1
            Else
                NNelem(ii, 2) = NNelem(ie, 2)
            End If
            NumMat(ii) = numb
            AngleYBar(ii) = angleb
            If Ntype = 3 Then
                If i = nb Then
                    If kind = 1 Or kind = 4 Then
                        KindElem(ii) = 4
                    Else
                        KindElem(ii) = 2
                    End If
                Else
                    KindElem(ii) = 2
                End If
            End If
        Next i
        NNelem(ie, 2) = npointb + 1
        If Ntype = 3 Then
            If kind = 1 Or kind = 3 Then
                KindElem(ie) = 3
            Else
                KindElem(ie) = 2
            End If
        End If

    End Sub

    Private Sub NewPoint(ByVal ie As Integer)
        '新節点座標の計算
        'ie･･･要素番号
        Dim i, ii, nb As Integer
        Dim b1, b2, b3, xb, yb, zb As Single

        nb = Ndiv - 1
        ReDim Xadd(nb), Yadd(nb), Zadd(nb)
        For ii = 1 To 2
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
        Next ii

        b1 = CSng(Ndiv)
        For i = 1 To nb
            b2 = CSng(i) / b1
            b3 = 1 - b2
            xb = b3 * XE(1) + b2 * XE(2)
            yb = b3 * YE(1) + b2 * YE(2)
            zb = b3 * ZE(1) + b2 * ZE(2)
            Xadd(i) = xb
            Yadd(i) = yb
            Zadd(i) = zb
        Next i

    End Sub

    Private Sub Bars3EDiv_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Ndiv = 4
        TextBox1.Text = LTrim(Str(KdivE1))
        TextBox2.Text = LTrim(Str(KdivE2))
        TextBox3.Text = LTrim$(Str$(Ndiv))

        If Ntype > 1 Then
            Label6.Visible = False
        End If

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim ie, ix, kind As Integer

        KdivE1 = Val(TextBox1.Text)
        KdivE2 = Val(TextBox2.Text)
        If KdivE1 = 0 Then
            KdivE1 = 1
            KdivE2 = Nelem
        Else
            If KdivE1 < 0 Or KdivE1 > Nelem Then
                aa$ = "開始要素番号が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                Exit Sub
            End If
            If KdivE2 < 0 Or KdivE2 > Nelem Then
                aa$ = "終了要素番号が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                Exit Sub
            End If
            If KdivE1 > KdivE2 Then
                aa$ = "終了要素番号が開始要素番号より小さくなっています！"
                MsgBox(aa$, 0, "データエラー")
                Exit Sub
            End If
        End If
        Ndiv = Val(TextBox3.Text)
        If Ndiv < 2 Then
            aa$ = "分割数が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            Exit Sub
        End If

        For ie = KdivE1 To KdivE2
            If Ntype > 2 Then
                kind = KindElem(ie)
            Else
                kind = Ntype
            End If
            Call NewPoint(ie)     '新節点の作成
            Call Assemble(ie, kind)     '集合処理
        Next ie

        KdataChange = 1
        aa$ = "ファイルへ保存しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New AnalDat6() '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
            frm.Show()
        End If

        Me.Close()

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class